package sun.java2d.loops;

import sun.java2d.SurfaceData;
import sun.java2d.SunGraphics2D;

public class DrawRect extends GraphicsPrimitive
{
    public static final String methodSignature;
    public static final int primTypeID;
    
    public static DrawRect locate(SurfaceType surfaceType, CompositeType compositeType, SurfaceType surfaceType2) {
        return (DrawRect)GraphicsPrimitiveMgr.locate(DrawRect.primTypeID, surfaceType, compositeType, surfaceType2);
    }
    
    protected DrawRect(SurfaceType surfaceType, CompositeType compositeType, SurfaceType surfaceType2) {
        super(DrawRect.methodSignature, DrawRect.primTypeID, surfaceType, compositeType, surfaceType2);
    }
    
    public DrawRect(long n, SurfaceType surfaceType, CompositeType compositeType, SurfaceType surfaceType2) {
        super(n, DrawRect.methodSignature, DrawRect.primTypeID, surfaceType, compositeType, surfaceType2);
    }
    
    public native void DrawRect(SunGraphics2D p0, SurfaceData p1, int p2, int p3, int p4, int p5);
    
    @Override
    public GraphicsPrimitive makePrimitive(SurfaceType obj, CompositeType obj2, SurfaceType surfaceType) {
        throw new InternalError("DrawRect not implemented for " + obj + " with " + obj2);
    }
    
    @Override
    public GraphicsPrimitive traceWrap() {
        return new DrawRect.TraceDrawRect(this);
    }
    
    static {
        methodSignature = "DrawRect(...)".toString();
        primTypeID = GraphicsPrimitive.makePrimTypeID();
    }
    
    private static class TraceDrawRect extends DrawRect
    {
        DrawRect target;
        
        public TraceDrawRect(DrawRect target) {
            super(target.getSourceType(), target.getCompositeType(), target.getDestType());
            this.target = target;
        }
        
        @Override
        public GraphicsPrimitive traceWrap() {
            return this;
        }
        
        @Override
        public void DrawRect(SunGraphics2D sunGraphics2D, SurfaceData surfaceData, int n, int n2, int n3, int n4) {
            GraphicsPrimitive.tracePrimitive(this.target);
            this.target.DrawRect(sunGraphics2D, surfaceData, n, n2, n3, n4);
        }
    }
}
